This tools reads the given version map for a directory, and checks to ensure
that, for each symbol listed in the export list, the corresponding definition is
tagged as __experimental, erroring out if its not.  In this way, we can ensure
that the EXPERIMENTAL api is kept in sync with the tags

Signed-off-by: Neil Horman <nhor...@tuxdriver.com>
CC: Thomas Monjalon <tho...@monjalon.net>
CC: "Mcnamara, John" <john.mcnam...@intel.com>
---
 buildtools/experimentalsyms.sh | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)
 create mode 100755 buildtools/experimentalsyms.sh

diff --git a/buildtools/experimentalsyms.sh b/buildtools/experimentalsyms.sh
new file mode 100755
index 000000000..dc01f71ba
--- /dev/null
+++ b/buildtools/experimentalsyms.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+MAPFILE=$1
+OBJFILE=$2
+
+if [ -d $MAPFILE ]
+then
+       exit 0
+fi
+
+if [ -d $OBJFILE ]
+then
+       exit 0
+fi
+
+for i in `awk 'BEGIN {found=0}
+               /.*EXPERIMENTAL.*/ {found=1}
+               /.*}.*;/ {found=0}
+               /.*;/ {if (found == 1) print $1}' $MAPFILE`
+do
+       SYM=`echo $i | sed -e"s/;//"`
+       objdump -t $OBJFILE | grep -q "\.text.*$SYM"
+       IN_TEXT=$?
+       objdump -t $OBJFILE | grep -q "\.text\.experimental.*$SYM"
+       IN_EXP=$?
+       if [ $IN_TEXT -eq 0 -a $IN_EXP -ne 0 ]
+       then
+               echo "$SYM is not flagged as experimental, but is listed in 
version map"
+               echo "Please add __experimental to the definition of $SYM"
+               exit 1
+       fi      
+done
+exit 0
+
-- 
2.14.3

Reply via email to